/*
 * freetype_exports.h - internal header with definitions of all exported functions
 *
 * Copyright (C) 2019 Thorsten Otto
 *
 * For conditions of distribution and use, see LICENSE.
 */

#ifndef LIBFUNC
#error "LIBFUNC must be defined before including this file"
#endif
#ifndef LIBFUNC2
#define LIBFUNC2(_fn, name, _nargs) LIBFUNC(_fn, name, _nargs)
#endif
			  /* Atari specific functions */
	LIBFUNC(freetype_slb_control, 2)

			  /* API functions */
	LIBFUNC(FT_Init_FreeType, 1)
	LIBFUNC(FT_Done_FreeType, 1)
	LIBFUNC(FT_New_Face, 4)
	LIBFUNC(FT_New_Memory_Face, 5)
	LIBFUNC(FT_Open_Face, 4)
	LIBFUNC(FT_Attach_File, 2)
	LIBFUNC(FT_Attach_Stream, 2)
	LIBFUNC(FT_Reference_Face, 1)
	LIBFUNC(FT_Done_Face, 1)
	LIBFUNC(FT_Select_Size, 2)
	LIBFUNC(FT_Request_Size, 2)
	LIBFUNC(FT_Set_Char_Size, 5)
	LIBFUNC(FT_Set_Pixel_Sizes, 3)
	LIBFUNC(FT_Load_Glyph, 3)
	LIBFUNC(FT_Load_Char, 3)
	LIBFUNC(FT_Set_Transform, 3)
	LIBFUNC(FT_Render_Glyph, 2)
	LIBFUNC(FT_Get_Kerning, 5)
	LIBFUNC(FT_Get_Track_Kerning, 4)
	LIBFUNC(FT_Get_Glyph_Name, 4)
	LIBFUNC(FT_Get_Postscript_Name, 1)
	LIBFUNC(FT_Select_Charmap, 2)
	LIBFUNC(FT_Set_Charmap, 2)
	LIBFUNC(FT_Get_Charmap_Index, 1)
	LIBFUNC(FT_Get_Char_Index, 2)
	LIBFUNC(FT_Get_First_Char, 2)
	LIBFUNC(FT_Get_Next_Char, 3)
	LIBFUNC(FT_Face_Properties, 3)
	LIBFUNC(FT_Get_Name_Index, 2)
	LIBFUNC(FT_Get_SubGlyph_Info, 7)
#if FREETYPE_VERSION >= 2010000L
	LIBFUNC(FT_Get_Color_Glyph_Layer, 5)
#else
	NOFUNC
#endif
	LIBFUNC(FT_Get_FSType_Flags, 1)
	LIBFUNC(FT_Face_GetCharVariantIndex, 3)
	LIBFUNC(FT_Face_GetCharVariantIsDefault, 3)
	LIBFUNC(FT_Face_GetVariantSelectors, 1)
	LIBFUNC(FT_Face_GetVariantsOfChar, 2)
	LIBFUNC(FT_Face_GetCharsOfVariant, 2)
	LIBFUNC(FT_MulDiv, 3)
	LIBFUNC(FT_MulFix, 2)
	LIBFUNC(FT_DivFix, 2)
	LIBFUNC(FT_RoundFix, 1)
	LIBFUNC(FT_CeilFix, 1)
	LIBFUNC(FT_FloorFix, 1)
	LIBFUNC(FT_Vector_Transform, 2)
	LIBFUNC(FT_Library_Version, 4)
	LIBFUNC(FT_Face_CheckTrueTypePatents, 1)
	LIBFUNC(FT_Face_SetUnpatentedHinting, 2)
	/* ftadvanc.h */
	LIBFUNC(FT_Get_Advance, 4)
	LIBFUNC(FT_Get_Advances, 5)
	/* ftbbox.h */
	LIBFUNC(FT_Outline_Get_BBox, 2)
	/* ftbdf.h */
	LIBFUNC(FT_Get_BDF_Charset_ID, 3)
	LIBFUNC(FT_Get_BDF_Property, 3)
	/* ftbitmap.h */
	LIBFUNC(FT_Bitmap_Init, 1)
	LIBFUNC(FT_Bitmap_New, 1)
	LIBFUNC(FT_Bitmap_Copy, 3)
	LIBFUNC(FT_Bitmap_Embolden, 4)
	LIBFUNC(FT_Bitmap_Convert, 4)
#if FREETYPE_VERSION >= 2010000L
	LIBFUNC(FT_Bitmap_Blend, 6)
#else
	NOFUNC
#endif
	LIBFUNC(FT_GlyphSlot_Own_Bitmap, 1)
	LIBFUNC(FT_Bitmap_Done, 2)
	/* ftbzip2.h */
	LIBFUNC(FT_Stream_OpenBzip2, 1)
	/* ftcache.h */
	LIBFUNC(FTC_Manager_New, 7)
	LIBFUNC(FTC_Manager_Reset, 1)
	LIBFUNC(FTC_Manager_Done, 1)
	LIBFUNC(FTC_Manager_LookupFace, 3)
	LIBFUNC(FTC_Manager_LookupSize, 3)
	LIBFUNC(FTC_Node_Unref, 2)
	LIBFUNC(FTC_Manager_RemoveFaceID, 2)
	LIBFUNC(FTC_CMapCache_New, 2)
	LIBFUNC(FTC_CMapCache_Lookup, 4)
	LIBFUNC(FTC_ImageCache_New, 2)
	LIBFUNC(FTC_ImageCache_Lookup, 5)
	LIBFUNC(FTC_ImageCache_LookupScaler, 6)
	LIBFUNC(FTC_SBitCache_New, 2)
	LIBFUNC(FTC_SBitCache_Lookup, 5)
	LIBFUNC(FTC_SBitCache_LookupScaler, 6)
	/* ftcid.h */
	LIBFUNC(FT_Get_CID_Registry_Ordering_Supplement, 4)
	LIBFUNC(FT_Get_CID_Is_Internally_CID_Keyed, 2)
	LIBFUNC(FT_Get_CID_From_Glyph_Index, 3)
	/* ftcolor.h */
#if FREETYPE_VERSION >= 2010000L
	LIBFUNC(FT_Palette_Data_Get, 2)
	LIBFUNC(FT_Palette_Select, 3)
	LIBFUNC(FT_Palette_Set_Foreground_Color, 2)
#else
	NOFUNC
	NOFUNC
	NOFUNC
#endif
	/* fterrors.h */
#if FREETYPE_VERSION >= 2010000L
	LIBFUNC(FT_Error_String, 1)
#else
	NOFUNC
#endif
	/* ftfntfmt.h */
	LIBFUNC(FT_Get_Font_Format, 1)
	/* deprecated FT_Get_X11_Font_Format omitted */
	/* ftgasp.h */
	LIBFUNC(FT_Get_Gasp, 2)
	/* ftgemfnt.h */
	LIBFUNC(FT_Get_GemFNT_Header, 2)
	/* ftglyph.h */
#if FREETYPE_VERSION >= 2010000L
	LIBFUNC(FT_New_Glyph, 3)
#else
	NOFUNC
#endif
	LIBFUNC(FT_Get_Glyph, 2)
	LIBFUNC(FT_Glyph_Copy, 2)
	LIBFUNC(FT_Glyph_Transform, 3)
	LIBFUNC(FT_Glyph_Get_CBox, 3)
	LIBFUNC(FT_Glyph_To_Bitmap, 4)
	LIBFUNC(FT_Done_Glyph, 1)
	LIBFUNC(FT_Matrix_Multiply, 2)
	LIBFUNC(FT_Matrix_Invert, 1)
	/* ftgxval.h */
	LIBFUNC(FT_TrueTypeGX_Validate, 4)
	LIBFUNC(FT_TrueTypeGX_Free, 2)
	LIBFUNC(FT_ClassicKern_Validate, 3)
	LIBFUNC(FT_ClassicKern_Free, 2)
	/* ftgzip.h */
	LIBFUNC(FT_Stream_OpenGzip, 2)
	LIBFUNC(FT_Gzip_Uncompress, 5)
	/* ftlcdfil.h */
	LIBFUNC(FT_Library_SetLcdFilter, 2)
	LIBFUNC(FT_Library_SetLcdFilterWeights, 2)
#if FREETYPE_VERSION >= 2010000L
	LIBFUNC(FT_Library_SetLcdGeometry, 2)
#else
	NOFUNC
#endif
 	/* ftlist.h */
	LIBFUNC(FT_List_Find, 2)
	LIBFUNC(FT_List_Add, 2)
	LIBFUNC(FT_List_Insert, 2)
	LIBFUNC(FT_List_Remove, 2)
	LIBFUNC(FT_List_Up, 2)
	LIBFUNC(FT_List_Iterate, 3)
	LIBFUNC(FT_List_Finalize, 4)
 	/* ftlzw.h */
	LIBFUNC(FT_Stream_OpenLZW, 2)
 	/* ftmm.h */
	LIBFUNC(FT_Get_Multi_Master, 2)
	LIBFUNC(FT_Get_MM_Var, 2)
	LIBFUNC(FT_Done_MM_Var, 2)
	LIBFUNC(FT_Set_MM_Design_Coordinates, 3)
	LIBFUNC(FT_Set_Var_Design_Coordinates, 3)
	LIBFUNC(FT_Get_Var_Design_Coordinates, 3)
	LIBFUNC(FT_Set_MM_Blend_Coordinates, 3)
	LIBFUNC(FT_Get_MM_Blend_Coordinates, 3)
	LIBFUNC(FT_Set_Var_Blend_Coordinates, 3)
	LIBFUNC(FT_Get_Var_Blend_Coordinates, 3)
#if FREETYPE_VERSION >= 2010000L
	LIBFUNC(FT_Set_MM_WeightVector, 3)
	LIBFUNC(FT_Get_MM_WeightVector, 3)
#else
	NOFUNC
	NOFUNC
#endif
	LIBFUNC(FT_Get_Var_Axis_Flags, 3)
	LIBFUNC(FT_Set_Named_Instance, 2)
 	/* ftmodapi.h */
	LIBFUNC(FT_Add_Module, 2)
	LIBFUNC(FT_Get_Module, 2)
	LIBFUNC(FT_Remove_Module, 2)
	LIBFUNC(FT_Property_Set, 4)
	LIBFUNC(FT_Property_Get, 4)
	LIBFUNC(FT_Set_Default_Properties, 1)
	LIBFUNC(FT_Reference_Library, 1)
	LIBFUNC(FT_New_Library, 2)
	LIBFUNC(FT_Done_Library, 1)
	LIBFUNC(FT_Set_Debug_Hook, 3)
	LIBFUNC(FT_Add_Default_Modules, 1)
	LIBFUNC(FT_Get_TrueType_Engine_Type, 1)
 	/* ftotval.h */
	LIBFUNC(FT_OpenType_Validate, 7)
	LIBFUNC(FT_OpenType_Free, 2)
 	/* ftoutln.h */
	LIBFUNC(FT_Outline_Decompose, 3)
	LIBFUNC(FT_Outline_New, 4)
	LIBFUNC(FT_Outline_Done, 2)
	LIBFUNC(FT_Outline_Check, 1)
	LIBFUNC(FT_Outline_Get_CBox, 2)
	LIBFUNC(FT_Outline_Translate, 3)
	LIBFUNC(FT_Outline_Copy, 2)
	LIBFUNC(FT_Outline_Transform, 2)
	LIBFUNC(FT_Outline_Embolden, 2)
	LIBFUNC(FT_Outline_EmboldenXY, 3)
	LIBFUNC(FT_Outline_Reverse, 1)
	LIBFUNC(FT_Outline_Get_Bitmap, 3)
	LIBFUNC(FT_Outline_Render, 3)
	LIBFUNC(FT_Outline_Get_Orientation, 1)
 	/* ftpfr.h */
	LIBFUNC(FT_Get_PFR_Metrics, 5)
	LIBFUNC(FT_Get_PFR_Kerning, 4)
	LIBFUNC(FT_Get_PFR_Advance, 3)
 	/* ftrender.h */
	LIBFUNC(FT_Get_Renderer, 2)
	LIBFUNC(FT_Set_Renderer, 4)
 	/* ftsizes.h */
	LIBFUNC(FT_New_Size, 2)
	LIBFUNC(FT_Done_Size, 1)
	LIBFUNC(FT_Activate_Size, 1)
 	/* ftsnames.h */
	LIBFUNC(FT_Get_Sfnt_Name_Count, 1)
	LIBFUNC(FT_Get_Sfnt_Name, 3)
	LIBFUNC(FT_Get_Sfnt_LangTag, 3)
 	/* ftstroke.h */
	LIBFUNC(FT_Outline_GetInsideBorder, 1)
	LIBFUNC(FT_Outline_GetOutsideBorder, 1)
	LIBFUNC(FT_Stroker_New, 2)
	LIBFUNC(FT_Stroker_Set, 5)
	LIBFUNC(FT_Stroker_Rewind, 1)
	LIBFUNC(FT_Stroker_ParseOutline, 3)
	LIBFUNC(FT_Stroker_BeginSubPath, 3)
	LIBFUNC(FT_Stroker_EndSubPath, 1)
	LIBFUNC(FT_Stroker_LineTo, 2)
	LIBFUNC(FT_Stroker_ConicTo, 3)
	LIBFUNC(FT_Stroker_CubicTo, 4)
	LIBFUNC(FT_Stroker_GetBorderCounts, 4)
	LIBFUNC(FT_Stroker_ExportBorder, 3)
	LIBFUNC(FT_Stroker_GetCounts, 3)
	LIBFUNC(FT_Stroker_Export, 2)
	LIBFUNC(FT_Stroker_Done, 1)
	LIBFUNC(FT_Glyph_Stroke, 3)
	LIBFUNC(FT_Glyph_StrokeBorder, 4)
 	/* ftsynth.h */
	LIBFUNC(FT_GlyphSlot_Embolden, 1)
	LIBFUNC(FT_GlyphSlot_Oblique, 1)
 	/* fttrigon.h */
	LIBFUNC(FT_Sin, 1)
	LIBFUNC(FT_Cos, 1)
	LIBFUNC(FT_Tan, 1)
	LIBFUNC(FT_Atan2, 2)
	LIBFUNC(FT_Angle_Diff, 2)
	LIBFUNC(FT_Vector_Unit, 2)
	LIBFUNC(FT_Vector_Rotate, 2)
	LIBFUNC(FT_Vector_Length, 1)
	LIBFUNC(FT_Vector_Polarize, 3)
	LIBFUNC(FT_Vector_From_Polar, 3)
 	/* ftwinfnt.h */
	LIBFUNC(FT_Get_WinFNT_Header, 2)
 	/* t1tables.h */
	LIBFUNC(FT_Has_PS_Glyph_Names, 1)
	LIBFUNC(FT_Get_PS_Font_Info, 2)
	LIBFUNC(FT_Get_PS_Font_Private, 2)
	LIBFUNC(FT_Get_PS_Font_Value, 5)
 	/* tttables.h */
	LIBFUNC(FT_Get_Sfnt_Table, 2)
	LIBFUNC(FT_Load_Sfnt_Table, 5)
	LIBFUNC(FT_Sfnt_Table_Info, 4)
	LIBFUNC(FT_Get_CMap_Language_ID, 1)
	LIBFUNC(FT_Get_CMap_Format, 1)
	/* others */
	LIBFUNC(TT_New_Context, 1)
	LIBFUNC(TT_RunIns, 1)
	LIBFUNC(FT_Get_Module_Interface, 2)
	LIBFUNC(FT_Stream_New, 3)
	LIBFUNC(FT_Stream_Free, 2)
	LIBFUNC(FT_Stream_EnterFrame, 2)
	
#undef LIBFUNC
#undef LIBFUNC2
#undef NOFUNC
